Index: issm/trunk/src/m/plot/plot_highlightelements.m
===================================================================
--- issm/trunk/src/m/plot/plot_highlightelements.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_highlightelements.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_highlightelements(md,options,width,i);
+function plot_highlightelements(md,options,width,i)
 %PLOT_HIGHLIGHTELEMENTS - plot selected elements
 %
Index: issm/trunk/src/m/plot/plot_highlightvertices.m
===================================================================
--- issm/trunk/src/m/plot/plot_highlightvertices.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_highlightvertices.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_highlightvertices(md,options,width,i);
+function plot_highlightvertices(md,options,width,i)
 %PLOT_HIGHLIGHTVERTICES - plot selected vertices
 %
@@ -21,5 +21,5 @@
 	%Highlight
 	pos=getfieldvalue(options,'highlight',[]);
-	text(x(pos),y(pos),z(pos),num2str(transpose(pos)),...
+	text(x(pos),y(pos),z(pos),num2str(pos(:)),...
 		'backgroundcolor',[1 0 0],'HorizontalAlignment','center','VerticalAlignment','middle');
 else
@@ -34,5 +34,5 @@
 	%Highlight
 	pos=getfieldvalue(options,'highlight',[]);
-	text(x(pos),y(pos),z(pos),num2str(transpose(pos)),...
+	text(x(pos),y(pos),z(pos),num2str(pos(:)),...
 		'backgroundcolor',[1 0 0],'HorizontalAlignment','center','VerticalAlignment','middle');
 end
Index: issm/trunk/src/m/plot/plot_icefront.m
===================================================================
--- issm/trunk/src/m/plot/plot_icefront.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_icefront.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_icefront(md,options,width,i,data);
+function plot_icefront(md,options,width,i,data)
 %PLOT_ICEFRONT - plot segment on neumann BC
 %
Index: issm/trunk/src/m/plot/plot_importancefactors.m
===================================================================
--- issm/trunk/src/m/plot/plot_importancefactors.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_importancefactors.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_importancefactors(md,options,width,ii);
+function plot_importancefactors(md,options,width,ii)
 %PLOT_IMPORTANCEFACTORS - plot importance factors
 %
Index: issm/trunk/src/m/plot/plot_manager.m
===================================================================
--- issm/trunk/src/m/plot/plot_manager.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_manager.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_manager(md,options,subplotwidth,nlines,ncols,i);
+function plot_manager(md,options,subplotwidth,nlines,ncols,i)
 %PLOT__MANAGER - distribute the plots, called by plotmodel
 %
@@ -33,13 +33,13 @@
 			plot_highlightelements(md,options,subplotwidth,i);
 			return;
-		
+
 		case 'qmumean',
 			plot_qmumean(md,options,nlines,ncols,i);
 			return;
-		
+
 		case 'qmustddev',
 			plot_qmustddev(md,options,nlines,ncols,i);
 			return;
-		
+
 		case 'qmuhistnorm',
 			plot_qmuhistnorm(md,options,nlines,ncols,i);
@@ -118,5 +118,5 @@
 			plot_segments(md,options,subplotwidth,i,data)
 			return
-		
+
 		case 'quiver'
 			data=[md.initialization.vx md.initialization.vy]; %Go ahead and try plot_unit
@@ -199,5 +199,5 @@
 		error('cannot kmlgroundoverlay on multi-plots');
 	end
-	
+
 	%call routine to build kml file and image that goes with it.
 	kmlgroundoverlay(md,options);
Index: issm/trunk/src/m/plot/plot_manager.py
===================================================================
--- issm/trunk/src/m/plot/plot_manager.py	(revision 13975)
+++ issm/trunk/src/m/plot/plot_manager.py	(revision 13975)
@@ -0,0 +1,67 @@
+
+try:
+	import pylab as p
+except ImportError:
+	print "could not import pylab, matplotlib has not been installed, no plotting capabilities enabled"
+
+from pairoptions import *
+from checkplotoptions import checkplotoptions
+from plot_mesh import plot_mesh
+from processmesh import processmesh
+from processdata import processdata
+from plot_unit import plot_unit
+from applyoptions import applyoptions
+
+def plot_manager(md,options,subplotwidth,nlines,ncols,i):
+	'''
+	PLOT_MANAGER - distribute the plots called by plotmodel
+
+		Usage:
+			plot_manager(md,options,subplotwidth,i);
+
+		See also: PLOTMODEL, PLOT_UNIT
+	'''
+
+	#parse options and get a structure of options
+	options=checkplotoptions(md,options)
+	#print 'options:', options
+
+	#get data to be plotted
+	data=options.getfieldvalue('data');
+
+	#figure out if this is a special plot
+	if isinstance(data,(str,unicode)):
+
+		# convert string to lower case for a case-insensitive comparison
+		if data.lower()=='mesh': 
+			plot_mesh(md,options,nlines,ncols,i)
+			return
+		else:
+			print "WARNING: '%s' is not implemented or is not a valid string for option 'data'" % data
+
+	#elif data in vars(md):
+	#else:
+		#print "'data' not a string, plotting model properties yet to be implemented..."
+
+	#Overlay plot
+
+	#Gridded plot
+
+	#Section plot
+
+	#Profile plot
+
+	#process data and model
+	x,y,z,elements,is2d,isplanet=processmesh(md,data,options)
+	data2,datatype=processdata(md,data,options)
+
+	#standard plot
+	p.subplot(nlines,ncols,i)
+
+	#plot unit
+	plot_unit(x,y,z,elements,data2,is2d,isplanet,datatype,options)
+
+	#apply all options
+	applyoptions(md,data2,options)
+
+	#ground overlay on kml plot_unit
Index: issm/trunk/src/m/plot/plot_mesh.m
===================================================================
--- issm/trunk/src/m/plot/plot_mesh.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_mesh.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_mesh(md,options,nlines,ncols,i);
+function plot_mesh(md,options,nlines,ncols,i)
 %PLOT_MESH - plot model mesh
 %
Index: issm/trunk/src/m/plot/plot_mesh.py
===================================================================
--- issm/trunk/src/m/plot/plot_mesh.py	(revision 13975)
+++ issm/trunk/src/m/plot/plot_mesh.py	(revision 13975)
@@ -0,0 +1,30 @@
+
+try:
+	import pylab as p
+except ImportError:
+	print "could not import pylab, matplotlib has not been installed, no plotting capabilities enabled"
+
+from processmesh import processmesh
+from applyoptions import applyoptions
+
+def plot_mesh(md,options,nlines,ncols,i):
+	'''
+	PLOT_MESH - plot model mesh
+
+		Usage:
+			plot_mesh(md,options,nlines,ncols,i)
+
+		See also: PLOTMODEL
+	'''
+
+	x,y,z,elements,is2d,isplanet=processmesh(md,[],options)
+
+	if is2d:
+		p.subplot(nlines,ncols,i)
+		p.triplot(x,y,elements)
+	else:
+		print 'WARNING: only 2D mesh plot is currently implemented'
+	
+	#apply options
+	options.addfielddefault('title','Mesh')
+	applyoptions(md,[],options)
Index: issm/trunk/src/m/plot/plot_none.m
===================================================================
--- issm/trunk/src/m/plot/plot_none.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_none.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_none(md,options,nlines,ncols,i);
+function plot_none(md,options,nlines,ncols,i)
 %PLOT_NONE - plot nothing, just apply options
 %
Index: issm/trunk/src/m/plot/plot_overlay.m
===================================================================
--- issm/trunk/src/m/plot/plot_overlay.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_overlay.m	(revision 13975)
@@ -25,5 +25,4 @@
 	error('buildoverlay error message: overlay not supported for quiver plots');
 end
-
 
 %radar power
@@ -150,5 +149,7 @@
 	options=changefieldvalue(options,'caxis',[data_min data_max]); % force caxis so that the colorbar is ready
 end
-options=addfielddefault(options,'axis','equal off');              % default axis
+options=addfielddefault(options,'xlim',xlim);        % default xlim
+options=addfielddefault(options,'ylim',ylim);        % default ylim
+options=addfielddefault(options,'axis','equal off'); % default axis
 applyoptions(md,data,options);
 drawnow
Index: issm/trunk/src/m/plot/plot_parthist.m
===================================================================
--- issm/trunk/src/m/plot/plot_parthist.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_parthist.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_parthist(md,options,nlines,ncols,i);
+function plot_parthist(md,options,nlines,ncols,i)
 %PLOT_PARTHIST - plot partitioning histogram
 %
Index: issm/trunk/src/m/plot/plot_parthistn.m
===================================================================
--- issm/trunk/src/m/plot/plot_parthistn.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_parthistn.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_parthist(md,options,nlines,ncols,i);
+function plot_parthist(md,options,nlines,ncols,i)
 %PLOT_PARTHIST - plot partitioning histogram
 %
Index: issm/trunk/src/m/plot/plot_parthistw.m
===================================================================
--- issm/trunk/src/m/plot/plot_parthistw.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_parthistw.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_parthist(md,options,nlines,ncols,i);
+function plot_parthist(md,options,nlines,ncols,i)
 %PLOT_PARTHIST - plot partitioning histogram
 %
Index: issm/trunk/src/m/plot/plot_penalties.m
===================================================================
--- issm/trunk/src/m/plot/plot_penalties.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_penalties.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_penalties(md,options,width,i);
+function plot_penalties(md,options,width,i)
 %PLOT_PENALTIES - plot penalties
 %
Index: issm/trunk/src/m/plot/plot_qmu_mass_flux_segments.m
===================================================================
--- issm/trunk/src/m/plot/plot_qmu_mass_flux_segments.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_qmu_mass_flux_segments.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_qmu_mass_flux_segments(md,options,nlines,ncols,i);
+function plot_qmu_mass_flux_segments(md,options,nlines,ncols,i)
 %PLOT_QMU_MASS_FLUX_SEGMENTS - plot segments from the qmu analysis of mass fluxes
 %
@@ -27,5 +27,5 @@
 
 		%plot normals
-		
+
 		for j=1:length(segments),
 			xstart=mean([segments(j,1) segments(j,3)]);
Index: issm/trunk/src/m/plot/plot_qmuhistnorm.m
===================================================================
--- issm/trunk/src/m/plot/plot_qmuhistnorm.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_qmuhistnorm.m	(revision 13975)
@@ -1,8 +1,7 @@
-function plot_qmuhistnorm(md,options,nlines,ncols,index);
+function plot_qmuhistnorm(md,options,nlines,ncols,index)
 
 %prepare plot
 subplot(nlines,ncols,index); 
 hold on
-
 
 %recover histnorm data
Index: issm/trunk/src/m/plot/plot_qmumean.m
===================================================================
--- issm/trunk/src/m/plot/plot_qmumean.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_qmumean.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_qmumean(md,options,nlines,ncols,i);
+function plot_qmumean(md,options,nlines,ncols,i)
 %PLOT_QMUMEAN - plot mean of a scaled response 
 %
Index: issm/trunk/src/m/plot/plot_qmustddev.m
===================================================================
--- issm/trunk/src/m/plot/plot_qmustddev.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_qmustddev.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_qmustddev(md,options,nlines,ncols,i);
+function plot_qmustddev(md,options,nlines,ncols,i)
 %PLOT_QMUMEAN - plot stddev of a scaled response 
 %
@@ -47,5 +47,4 @@
 end
 
-
 %now, project onto vertices
 responses_on_node=responses(md.qmu.partition+1);
Index: issm/trunk/src/m/plot/plot_referential.m
===================================================================
--- issm/trunk/src/m/plot/plot_referential.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_referential.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_referential(md,options,width,i,data);
+function plot_referential(md,options,width,i,data)
 %PLOT_PRESSURELOAD - plot segment on neumann BC
 %
Index: issm/trunk/src/m/plot/plot_riftfraction.m
===================================================================
--- issm/trunk/src/m/plot/plot_riftfraction.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_riftfraction.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_riftfraction(md,options,nlines,ncols,index);
+function plot_riftfraction(md,options,nlines,ncols,index)
 %PLOT_RIFTFRACTION - plot rift fractions
 %
Index: issm/trunk/src/m/plot/plot_riftnumbering.m
===================================================================
--- issm/trunk/src/m/plot/plot_riftnumbering.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_riftnumbering.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_riftnumbering(md,options,nlines,ncols,index);
+function plot_riftnumbering(md,options,nlines,ncols,index)
 %PLOT_RIFTNUMBERING - plot rift penetration + numbering of all rift vertices, as well as rift numbers.
 %
@@ -88,5 +88,4 @@
 end
 
-
 %apply options
 options=addfielddefault(options,'title','Rift/Fault location');
Index: issm/trunk/src/m/plot/plot_riftpenetration.m
===================================================================
--- issm/trunk/src/m/plot/plot_riftpenetration.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_riftpenetration.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_rifpenetration(md,options,nlines,ncols,index);
+function plot_rifpenetration(md,options,nlines,ncols,index)
 %PLOT_RIFTPENETRATION - plot rift penetration
 %
Index: issm/trunk/src/m/plot/plot_riftrelvel.m
===================================================================
--- issm/trunk/src/m/plot/plot_riftrelvel.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_riftrelvel.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_riftrelvel(md,options,nlines,ncols,index);
+function plot_riftrelvel(md,options,nlines,ncols,index)
 %PLOT_RIFTRELVEL - plot rift relative velocities
 %
@@ -15,4 +15,7 @@
 end
 options=addfielddefault(options,'scaling',2);
+
+%markersize: 
+markersize=getfieldvalue(options,'markersize',1);
 
 %recover vx and vy:
@@ -38,9 +41,4 @@
 hold on
 
-%plot mesh boundaries
-for i=1:size(md.mesh.segments,1),
-	plot(x(md.mesh.segments(i,1:2)),y(md.mesh.segments(i,1:2)),'k-');
-end
-
 %plot rifts vel
 h3=[];
@@ -63,5 +61,5 @@
 end
 for i=1:size(md.rifts.riftstruct,1),
-	
+
 	%get nodes on rift
 	penaltypairs=md.rifts.riftstruct(i).penaltypairs;
@@ -81,8 +79,8 @@
 		%if penetration is negative, plot in black, positive, plot in red;: ie: if rift is closing, black, if rift is opening, red.
 		if(penetration>0),
-			p2=plot(x(penaltypairs(j,1)) ,y(penaltypairs(j,1)),'*'); set(p2,'Color',[140 140 140]/255);
+			p2=plot(x(penaltypairs(j,1)) ,y(penaltypairs(j,1)),'.','MarkerSize',markersize); set(p2,'Color',[140 140 140]/255);
 			isp2=1;
 		else
-			p1=plot(x(penaltypairs(j,1)) ,y(penaltypairs(j,1)),'k*');
+			p1=plot(x(penaltypairs(j,1)) ,y(penaltypairs(j,1)),'k.','MarkerSize',markersize);
 			isp1=1;
 		end
@@ -90,16 +88,19 @@
 
 	%point out the tips
-	h2=plot(x(md.rifts.riftstruct(i).tips(1)),y(md.rifts.riftstruct(i).tips(1)),'g*');
-	plot(x(md.rifts.riftstruct(i).tips(2)),y(md.rifts.riftstruct(i).tips(2)),'g*');
+	h2=plot(x(md.rifts.riftstruct(i).tips(1)),y(md.rifts.riftstruct(i).tips(1)),'g.','MarkerSize',markersize);
+	plot(x(md.rifts.riftstruct(i).tips(2)),y(md.rifts.riftstruct(i).tips(2)),'g.','MarkerSize',markersize);
 	segments=md.rifts.riftstruct(i).segments(:,1:2);
 end
+
+faulttitle=getfieldvalue(options','faulttitle','faults');
+rifttitle=getfieldvalue(options','rifttitle','rifts');
 %legend
 if strcmpi(getfieldvalue(options,'legend','on'),'on'),
 	if isp1 & isp2
-		l=legend([h1,h2,p1,p2],'mesh boundaries','crack tips','faults','rifts');
+		l=legend([h1,h2,p1,p2],'mesh boundaries','crack tips',faulttitle,rifttitle);
 	elseif isp1
-		l=legend([h1,h2,p1],'mesh boundaries','crack tips','faults');
+		l=legend([h1,h2,p1],'mesh boundaries','crack tips',faulttitle);
 	elseif isp2
-		l=legend([h1,h2,p2],'mesh boundaries','crack tips','rifts');
+		l=legend([h1,h2,p2],'mesh boundaries','crack tips',rifttitle);
 	else
 		l=legend([h1,h2],'mesh boundaries','crack tips');
Index: issm/trunk/src/m/plot/plot_rifts.m
===================================================================
--- issm/trunk/src/m/plot/plot_rifts.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_rifts.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_rifts(md,options,nlines,ncols,index);
+function plot_rifts(md,options,nlines,ncols,index)
 %PLOT_RIFTS - plot rifts in a mesh
 %
@@ -16,5 +16,5 @@
 offset=getfieldvalue(options,'offset',500);
 if isstruct(md.rifts.riftstruct),
-	
+
 	for i=1:size(md.rifts.riftstruct,1),
 		penaltypairs=md.rifts.riftstruct(i).penaltypairs;
Index: issm/trunk/src/m/plot/plot_riftvel.m
===================================================================
--- issm/trunk/src/m/plot/plot_riftvel.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_riftvel.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_riftvel(md,options,nlines,ncols,index);
+function plot_riftvel(md,options,nlines,ncols,index)
 %PLOT_RIFTVEL - plot rift velocity
 %
@@ -89,5 +89,4 @@
 end
 
-
 %legend
 if isp1 & isp2
Index: issm/trunk/src/m/plot/plot_sarpwr.m
===================================================================
--- issm/trunk/src/m/plot/plot_sarpwr.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_sarpwr.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_sarpwr(md,options,width,i);
+function plot_sarpwr(md,options,width,i)
 %PLOT_SARPWR - plot radar image
 %
@@ -17,5 +17,5 @@
 	md.mesh.z=md.mesh.z*unit;
 end
-					
+
 imagesc(md.radaroverlay.x,md.radaroverlay.y,double(md.radaroverlay.pwr)),set(gca,'YDir','normal');colormap(gray);
 
Index: issm/trunk/src/m/plot/plot_scatter.m
===================================================================
--- issm/trunk/src/m/plot/plot_scatter.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_scatter.m	(revision 13975)
@@ -1,5 +1,5 @@
-function plot_scatter(x,y,level,options),
+function plot_scatter(x,y,level,varargin),
 
-if nargin==3, options=pairoptions(); end
+options=pairoptions(varargin{:}); 
 
 %check input
@@ -13,4 +13,6 @@
 Siz=length(level);
 nlab=10;
+%Min=0;
+%Max=1300;
 
 %OK, should we create a new colorbar for the occasion?
Index: issm/trunk/src/m/plot/plot_segments.m
===================================================================
--- issm/trunk/src/m/plot/plot_segments.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_segments.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_segments(md,options,width,i,datai);
+function plot_segments(md,options,width,i,datai)
 %PLOT_SEGMENTS - plot segments, with different colors according to segment markers.
 %
@@ -42,5 +42,4 @@
 	h3=plot(xstart,ystart,'r*');
 
-
 else
 	error('plot_segments: 3d plot of segments not supported yet!');
Index: issm/trunk/src/m/plot/plot_tensor.m
===================================================================
--- issm/trunk/src/m/plot/plot_tensor.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_tensor.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_tensor(md,options,width,i,type);
+function plot_tensor(md,options,width,i,type)
 %PLOT_TENSOR - plot tensor components
 %
Index: issm/trunk/src/m/plot/plot_tensor_components.m
===================================================================
--- issm/trunk/src/m/plot/plot_tensor_components.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_tensor_components.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_tensor_components(md,options,width,i,tensor,type,plot_options);
+function plot_tensor_components(md,options,width,i,tensor,type,plot_options)
 %PLOT_TENSOR_COMPONENT - plot component of a tensor
 %
Index: issm/trunk/src/m/plot/plot_tensor_principal.m
===================================================================
--- issm/trunk/src/m/plot/plot_tensor_principal.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_tensor_principal.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_tensor_principal(md,options,width,i,tensor,type,plot_options);
+function plot_tensor_principal(md,options,width,i,tensor,type,plot_options)
 %PLOT_TENSOR_PRINCIPAL - plot principal values
 %
Index: issm/trunk/src/m/plot/plot_tensor_principalaxis.m
===================================================================
--- issm/trunk/src/m/plot/plot_tensor_principalaxis.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_tensor_principalaxis.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_tensor_principalaxis(md,options,width,i,tensor,type,plot_options);
+function plot_tensor_principalaxis(md,options,width,i,tensor,type,plot_options)
 %PLOT_TENSOR_PRINCIPALAXIS - plot ytensor principal axis
 %
Index: issm/trunk/src/m/plot/plot_transient_movie.m
===================================================================
--- issm/trunk/src/m/plot/plot_transient_movie.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_transient_movie.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_transient_movie(md,options,width,i);
+function plot_transient_movie(md,options,width,i)
 %PLOT_TRANSIENT_MOVIE - plot a transient result as a movie
 %   Usage:
Index: issm/trunk/src/m/plot/plot_unit.py
===================================================================
--- issm/trunk/src/m/plot/plot_unit.py	(revision 13975)
+++ issm/trunk/src/m/plot/plot_unit.py	(revision 13975)
@@ -0,0 +1,53 @@
+
+try:
+	import pylab as p
+except ImportError:
+	print "could not import pylab, matplotlib has not been installed, no plotting capabilities enabled"
+
+def plot_unit(x,y,z,elements,data,is2d,isplanet,datatype,options):
+	"""
+	PLOT_UNIT - unit plot, display data
+
+		Usage:
+			plot_unit(x,y,z,elements,data,is2d,isplanet,datatype,options)
+
+		See also: PLOTMODEL, PLOT_MANAGER
+	"""
+
+	#edgecolor
+	edgecolor=options.getfieldvalue('edgecolor','None')
+
+	#number of colorlevels for plots
+	colorlevels=options.getfieldvalue('colorlevels',256)
+
+	if datatype==1:
+		#element plot
+		if is2d:
+			p.tripcolor(x,y,elements,data,colorlevels)
+		else:
+			raise ValueError('plot_unit error: 3D element plot not supported yet')
+		return
+
+	elif datatype==2:
+		#node plot
+		if is2d:
+			p.tricontourf(x,y,elements,data,colorlevels)
+		else:
+			raise ValueError('plot_unit error: 3D node plot not supported yet')
+		return
+
+	elif datatype==3:
+		print 'plot_unit message: quiver plot not implemented yet'
+		return
+
+	elif datatype==4:
+		#P1 patch plot
+		print 'plot_unit message: P1 patch plot not implemented yet'
+		return
+
+	elif datatype==5:
+		print 'plot_unit message: P0 patch plot not implemented yet'
+		return
+
+	else:
+		raise ValueError('datatype=%d not supported' % datatype)
Index: issm/trunk/src/m/plot/plot_vertexnumbering.m
===================================================================
--- issm/trunk/src/m/plot/plot_vertexnumbering.m	(revision 13405)
+++ issm/trunk/src/m/plot/plot_vertexnumbering.m	(revision 13975)
@@ -1,3 +1,3 @@
-function plot_vertexnumbering(md,options,width,i);
+function plot_vertexnumbering(md,options,width,i)
 %PLOT_VERTEXNUMBERING - plot vertex numbering
 %
@@ -25,5 +25,5 @@
 	%Highlight
 	pos=getfieldvalue(options,'highlight',[]);
-	text(x(pos),y(pos),z(pos),num2str(transpose(pos)),...
+	text(x(pos),y(pos),z(pos),num2str(pos(:)),...
 		'backgroundcolor',[1 0 0],'HorizontalAlignment','center','VerticalAlignment','middle');
 else
@@ -42,5 +42,5 @@
 	%Highlight
 	pos=getfieldvalue(options,'highlight',[]);
-	text(x(pos),y(pos),z(pos),num2str(transpose(pos)),...
+	text(x(pos),y(pos),z(pos),num2str(pos(:)),...
 		'backgroundcolor',[1 0 0],'HorizontalAlignment','center','VerticalAlignment','middle');
 end
Index: issm/trunk/src/m/plot/plotmodel.py
===================================================================
--- issm/trunk/src/m/plot/plotmodel.py	(revision 13975)
+++ issm/trunk/src/m/plot/plotmodel.py	(revision 13975)
@@ -0,0 +1,67 @@
+
+try:
+	import pylab as p
+except ImportError:
+	print "could not import pylab, matplotlib has not been installed, no plotting capabilities enabled"
+
+#from pairoptions import *
+from plotoptions import plotoptions
+from plot_manager import plot_manager
+from math import ceil, sqrt
+
+def plotmodel(md,*args):
+	'''
+	at command prompt, type 'plotdoc' for additional documentation
+	'''
+
+	#First process options 
+	options=plotoptions(*args)
+
+	#get number of subplots
+	subplotwidth=ceil(sqrt(options.numberofplots))
+	
+	#if nlines and ncols specified, then bypass
+	if options.list[0].exist('nlines'):
+		nlines=options.list[0].getfieldvalue('nlines')
+		nl=True
+	else:
+		nlines=subplotwidth
+		nl=False
+	
+	if options.list[0].exist('ncols'):
+		ncols=options.list[0].getfieldvalue('ncols')
+		nc=True
+	else:
+		ncols=subplotwidth
+		nc=False
+	
+	#check that nlines and ncols were given at the same time!
+	if not nl==nc:
+		raise StandardError('error: nlines and ncols need to be specified together, or not at all')
+	
+	#Get figure number and number of plots
+	figurenumber=options.figurenumber
+	numberofplots=options.numberofplots
+	
+	#Go through plots
+	if numberofplots:
+		
+		#Create figure
+		#plots will be visible by default if ipython is run in interactive mode (invoked by ipython --pylab)
+		#handling the 'visible' option will need some check on whether ipython is currently in interactive or non-interactive mode
+
+		#if figsize specified
+		if options.list[0].exist('figsize'):
+			figsize=options.list[0].getfieldvalue('figsize')
+			p.figure(figurenumber,figsize=figsize)
+		else:
+			p.figure(figurenumber)
+			
+		#try:
+		for i in xrange(numberofplots):
+			plot_manager(options.list[i].getfieldvalue('model',md),options.list[i],subplotwidth,nlines,ncols,i)
+		#except StandardError:
+		#	print 'error in plot_manager'
+	else:
+		raise StandardError('plotmodel error message: no output data found.')
+			
Index: issm/trunk/src/m/plot/processdata.m
===================================================================
--- issm/trunk/src/m/plot/processdata.m	(revision 13405)
+++ issm/trunk/src/m/plot/processdata.m	(revision 13975)
@@ -1,3 +1,3 @@
-function [data datatype]=processdata(md,data,options);
+function [data datatype]=processdata(md,data,options)
 %PROCESSDATA - process data to be plotted
 %
@@ -48,8 +48,8 @@
 end
 
-%get datatype
+%get datasize
 datasize=size(data);
 
-%Process NaN if any (do not now before mask is applied)
+%Process NaN if any (do not know before mask is applied)
 if exist(options,'nan')
 	data(find(isnan(data)))=getfieldvalue(options,'nan',0);
@@ -74,5 +74,5 @@
 		error('plotmodel error message: data not supported yet');
 	end
-	
+
 	%quiver?
 	if datasize(2)>1,
Index: issm/trunk/src/m/plot/processdata.py
===================================================================
--- issm/trunk/src/m/plot/processdata.py	(revision 13975)
+++ issm/trunk/src/m/plot/processdata.py	(revision 13975)
@@ -0,0 +1,79 @@
+from math import isnan
+import numpy as npy
+
+def processdata(md,data,options):
+	"""
+	PROCESSDATA - process data to be plotted
+
+		datatype = 1 -> elements
+		datatype = 2 -> nodes
+		datatype = 3 -> node quivers
+		datatype = 4 -> patch
+
+		Usage:
+			data,datatype=processdata(md,data,options);
+
+		See also: PLOTMODEL, PROCESSMESH
+	"""
+
+	#check format
+	if (len(data)==0 or (len(data)==1 and not isinstance(data,dict) and isnan(data).all())):
+		raise ValueError("processdata error message: 'data' provided is empty")
+
+	#needed later on
+	if md.mesh.numberofvertices2d:
+		numberofvertices2d=md.mesh.numberofvertices2d
+		numberofelements2d=md.mesh.numberofelements2d
+	else:
+		numberofvertices2d=npy.nan
+		numberofelements2d=npy.nan
+
+	#process patch
+
+	#initialize datatype
+	datatype=0
+
+	#get datasize
+	if npy.ndim(data)==1:
+		datasize=npy.array([len(data),1])
+	else:
+		datasize=npy.shape(data)
+	
+	#process NaN's if any
+	if options.exist('nan'):
+		data[npy.isnan(data)]=options.getfieldvalue('nan',0)
+
+	#non-patch processing 
+
+	#element data
+	if datasize[0]==md.mesh.numberofelements and datasize[1]==1:
+		
+		#initialize datatype if non patch
+		if datatype!=4 and datatype!=5:
+			datatype=1
+
+		#mask?
+
+		#log?
+
+	#node data
+	if datasize[0]==md.mesh.numberofvertices and datasize[1]==1:
+		datatype=2
+
+		#mask?
+
+		#log?
+
+	#layer projection?
+
+	#control arrow density if quiver plot
+
+	#convert rank-2 array to rank-1
+	if npy.ndim(data)==2 and npy.shape(data)[1]==1:
+		data=data.reshape(-1,)
+
+	#if datatype is still zero, error out
+	if datatype==0:
+		raise ValueError("processdata error: data provided not recognized or not supported")
+	else:
+		return data, datatype
Index: issm/trunk/src/m/plot/processmesh.m
===================================================================
--- issm/trunk/src/m/plot/processmesh.m	(revision 13405)
+++ issm/trunk/src/m/plot/processmesh.m	(revision 13975)
@@ -1,3 +1,3 @@
-function [x y z elements is2d isplanet]=processmesh(md,data,options);
+function [x y z elements is2d isplanet]=processmesh(md,data,options)
 %PROCESSMESH - process mesh to be plotted
 %
@@ -36,5 +36,4 @@
 		z=md.mesh.z;
 	end
-
 
 	if isprop(md.mesh,'elements2d'), elements2d=md.mesh.elements2d; end
Index: issm/trunk/src/m/plot/processmesh.py
===================================================================
--- issm/trunk/src/m/plot/processmesh.py	(revision 13975)
+++ issm/trunk/src/m/plot/processmesh.py	(revision 13975)
@@ -0,0 +1,87 @@
+from math import isnan
+
+def processmesh(md,data,options):
+	"""
+	PROCESSMESH - process the mesh for plotting
+
+	Usage:
+		[x y z elements is2d]=processmech(md,data,options)
+
+	See also: PLOTMODEL, PROCESSDATA
+	"""
+
+	#some checks
+	if md.mesh.numberofvertices==0:
+		raise ValueError('processmesh error: mesh is empty')
+	if md.mesh.numberofvertices==md.mesh.numberofelements:
+		raise ValueError('processmesh error: the number of elements is the same as the number of nodes')
+
+	if len(data)==0 or not isinstance(data,dict):
+		
+		if 'latlon' not in options.getfieldvalue('coord','xy').lower(): #convert to lower case for comparison
+			x=md.mesh.x
+			if not isnan(md.mesh.x2d): x2d=md.mesh.x2d
+			y=md.mesh.y
+			if not isnan(md.mesh.y2d): y2d=md.mesh.y2d
+		else:
+			x=md.mesh.long
+			y=md.mesh.lat
+
+		z_field=options.getfieldvalue('z',md.mesh.z)
+		#if isinstance(z_field,basestring): # how could z be a string?
+		#	z=md.(z_field)
+		if isinstance(z_field,(int,long,float)):  # isnumeric
+			z=z_field
+		else:
+			z=md.mesh.z
+		
+		if not isnan(md.mesh.elements2d): 
+			elements2d=md.mesh.elements2d
+			elements2d=elements2d-1
+		# subtract one since python indexes from zero
+		elements=md.mesh.elements
+		elements=elements-1
+
+		#is it a 2D plot?
+		if md.mesh.dimension==2:
+			is2d=1
+		elif md.mesh.dimension==3:
+			if options.getfieldvalue('layer',0)>=1:
+				is2d=1
+			else:
+				is2d=0
+		else:
+			raise ValueError('processmesh error: dim = %d not supported' % md.mesh.dimension)
+
+		#layer projection?
+		if options.getfieldvalue('layer',0)>=1:
+			 if 'latlon' in options.getfieldvalue('coord','xy').lower():
+				 raise ValueError('processmesh error: cannot work with 3D mesh in lat-lon coords')
+			#we modify the mesh temporarily to a 2D mesh from which the 3D mesh was extruded
+			 x=x2d
+			 y=y2d
+			 z=zeros(size(x2d))
+			 elements=elements2d
+	
+	else:
+		#Process mesh for plotting 
+		if md.mesh.dimension==2:
+			is2d=1
+		else:
+			# process polycollection here for 3D plot
+			is2d=0
+	
+	#units
+	if options.exist('unit'):
+		unit=options.getfieldvalue('unit')
+		x=x*unit
+		y=y*unit
+		z=z*unit
+
+	#is model a member of planet class? (workaround until planet class defined)
+	if md.__class__.__name__!='model':
+		isplanet=1
+	else:
+		isplanet=0
+
+	return x,y,z,elements,is2d,isplanet
